--[[ 	GupPet by Gup 	]]--

-- CONSTANT
GUPPET_INTERFACEVERSION = 0.204;

-- SAVED VARS
GUPPET_INTERFACEOPTIONS = { MainUIFrameRelativePoint = "CENTER", MainUIFramexOfs = 0 ,  MainUIFrameyOfs = 0 , MainUIFrameScale = 1 , MainUIFrameShow = true , MainUIFrameDrag = true};

-- TEMP VARS
GUPPET_INTERFACE = { Init = 0};

function GupPetOptionInterface()
	GupPet_Debug( "GupPetOptionInterface Start" );

-- ############################################# 
-- #############################################  MAIN
-- #############################################	
	if (GUPPET_INTERFACE.Init == 0 ) then

		GUPPET_INTERFACE.MainScherm = CreateFrame( "Frame", "GupPetPanel", nil , "GupPetFrameOptionMain" ); 
		GUPPET_INTERFACE.MainScherm.name = "Gup Pet";
		
		getglobal(GUPPET_INTERFACE.MainScherm:GetName() .. "Text"):SetText("|cFFFFDE00Gup Pet") ;
			
		GUPPET_INTERFACE.MainScherm.VERSION = CreateFrame("SimpleHTML", "Overall" , GUPPET_INTERFACE.MainScherm );
		GUPPET_INTERFACE.MainScherm.VERSION:SetWidth(400); 
		GUPPET_INTERFACE.MainScherm.VERSION:SetHeight(50); 
		GUPPET_INTERFACE.MainScherm.VERSION:SetPoint("TOPLEFT", 30 , -44) ;
		GUPPET_INTERFACE.MainScherm.VERSION:SetFont('Fonts\\FRIZQT__.TTF', 12); 
	end
		
		if GUPPET_OPTIONS.NewVersionFound <= GupPet_GetVersion()  then
		
			GUPPET_INTERFACE.MainScherm.VERSION:SetText("<html><body><p>"..
															GUPPET_TEXT_OPTIONUI_MAIN_AUTHOR .."|cffee4400 Gup|r<br /><br />"..
															GUPPET_TEXT_OPTIONUI_MAIN_TOTAL .."|cffee4400"..GupPet_GetVersion()..
															" </p></body></html>"    ) ;
		else
			GUPPET_INTERFACE.MainScherm.VERSION:SetText("<html><body><p>"..
															GUPPET_TEXT_OPTIONUI_MAIN_AUTHOR .."|cffee4400 Gup|r<br /><br />"..
															GUPPET_TEXT_OPTIONUI_MAIN_TOTAL .."|cffee4400"..GupPet_GetVersion().."|r ".. GUPPET_TEXT_OPTIONUI_MAIN_NEWVERSIONFOUND.."|cffee4400".. GUPPET_OPTIONS.NewVersionFound..
															" </p></body></html>"    ) ;
		end
		
	if (GUPPET_INTERFACE.Init == 0 ) then
		
		----------------------------------------------------------------------------
		GUPPET_INTERFACE.MainScherm.SlashFrame = CreateFrame("FRAME", "SlashFrame", GUPPET_INTERFACE.MainScherm , "GupPetFrameOptionFrame");
 		GUPPET_INTERFACE.MainScherm.SlashFrame:SetWidth(393);
		GUPPET_INTERFACE.MainScherm.SlashFrame:SetHeight(100);	
		GUPPET_INTERFACE.MainScherm.SlashFrame:SetPoint("TOPLEFT", 10 , -160);
		getglobal("SlashFrame" .. "SubTitle"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_MAIN_SLASHFRAME) ;	
				
		 -- slash commands
		GUPPET_INTERFACE.MainScherm.SLASH = CreateFrame("SimpleHTML", "Slash" , GUPPET_INTERFACE.MainScherm.SlashFrame );
		GUPPET_INTERFACE.MainScherm.SLASH:SetWidth(300); 
		GUPPET_INTERFACE.MainScherm.SLASH:SetHeight(50); 
		GUPPET_INTERFACE.MainScherm.SLASH:SetPoint("TOPLEFT", 10 , -10);
		GUPPET_INTERFACE.MainScherm.SLASH:SetText("<html><body><p>"..
															"|r/GP "..GUPPET_TEXT_OPTIONUI_MAIN_SLASH_1.."<br />"..
															"|r/GP "..GUPPET_TEXT_OPTIONUI_MAIN_SLASH_2.."<br />"..
															"|r/GP "..GUPPET_TEXT_OPTIONUI_MAIN_SLASH_3.."<br />"..
															"|r/GP "..GUPPET_TEXT_OPTIONUI_MAIN_SLASH_4.."<br />"..
															"|r/GP "..GUPPET_TEXT_OPTIONUI_MAIN_SLASH_5.."<br />"..
															"|r/GP "..GUPPET_TEXT_OPTIONUI_MAIN_SLASH_6.."<br />"..
															"|r/GP "..GUPPET_TEXT_OPTIONUI_MAIN_SLASH_7.."<br />"..
															" </p></body></html>"    ) ;
		GUPPET_INTERFACE.MainScherm.SLASH:SetFont('Fonts\\FRIZQT__.TTF', 10); 
		 		 
		----------------------------------------------------------------------------
		GUPPET_INTERFACE.MainScherm.UIFrame = CreateFrame("FRAME", "UIFrame", GUPPET_INTERFACE.MainScherm , "GupPetFrameOptionFrame");
 		GUPPET_INTERFACE.MainScherm.UIFrame:SetWidth(190);
		GUPPET_INTERFACE.MainScherm.UIFrame:SetHeight(125);	
		GUPPET_INTERFACE.MainScherm.UIFrame:SetPoint("TOPLEFT", 10 , -290);
		getglobal("UIFrame" .. "SubTitle"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_MAIN_UIFRAME) ;	
		
		 -- For the ingame button(s)
		GUPPET_INTERFACE.MainScherm.ToggleShow = CreateFrame("Button", "knop", GUPPET_INTERFACE.MainScherm.UIFrame , "UIPanelButtonTemplate");
		GUPPET_INTERFACE.MainScherm.ToggleShow:SetScript("OnClick", function ()  GupPetOptionToggleMainUIFrameShow() ; end) ;
		GUPPET_INTERFACE.MainScherm.ToggleShow:SetWidth(120); 
		GUPPET_INTERFACE.MainScherm.ToggleShow:SetHeight(20); 
		GUPPET_INTERFACE.MainScherm.ToggleShow:SetPoint("TOP",0,-10);
		
		if GUPPET_INTERFACEOPTIONS.MainUIFrameShow then
			GUPPET_INTERFACE.MainScherm.ToggleShow:SetText( GUPPET_TEXT_OPTIONUI_MAIN_SETHIDE );
		else
			GUPPET_INTERFACE.MainScherm.ToggleShow:SetText( GUPPET_TEXT_OPTIONUI_MAIN_SETSHOW );
		end	
		
		GUPPET_INTERFACE.MainScherm.ToggleDrag = CreateFrame("Button", "knop", GUPPET_INTERFACE.MainScherm.UIFrame , "UIPanelButtonTemplate");
		GUPPET_INTERFACE.MainScherm.ToggleDrag:SetScript("OnClick", function () GupPetOptionToggleMainUIFrameDrag();  end) ;
		GUPPET_INTERFACE.MainScherm.ToggleDrag:SetWidth(120); 
		GUPPET_INTERFACE.MainScherm.ToggleDrag:SetHeight(20); 
		GUPPET_INTERFACE.MainScherm.ToggleDrag:SetPoint("TOP",0, -40);
		
		if GUPPET_INTERFACEOPTIONS.MainUIFrameDrag then
			GUPPET_INTERFACE.MainScherm.ToggleDrag:SetText( GUPPET_TEXT_OPTIONUI_MAIN_SETLOCK );
		else
			GUPPET_INTERFACE.MainScherm.ToggleDrag:SetText( GUPPET_TEXT_OPTIONUI_MAIN_SETMOVABLE );
		end	
				
		GUPPET_INTERFACE.MainScherm.ScaleSlider = CreateFrame('Slider', "ScaleSlider", GUPPET_INTERFACE.MainScherm.UIFrame , 'OptionsSliderTemplate');
		GUPPET_INTERFACE.MainScherm.ScaleSlider:SetPoint('TOP', 0, -80);
		GUPPET_INTERFACE.MainScherm.ScaleSlider:SetOrientation('HORIZONTAL');
		GUPPET_INTERFACE.MainScherm.ScaleSlider:SetWidth(120) ;
		GUPPET_INTERFACE.MainScherm.ScaleSlider:SetHeight(20);
		GUPPET_INTERFACE.MainScherm.ScaleSlider:SetMinMaxValues(0.2 , 2.5 );
		GUPPET_INTERFACE.MainScherm.ScaleSlider:SetValueStep(0.05) ;
		GUPPET_INTERFACE.MainScherm.ScaleSlider:SetValue( GUPPET_INTERFACEOPTIONS.MainUIFrameScale );
		GUPPET_INTERFACE.MainScherm.ScaleSlider:SetScript("OnValueChanged", function (self)   GUPPET_INTERFACEOPTIONS.MainUIFrameScale = self:GetValue() ; GupPetUIInterface() ;      end);

		getglobal("ScaleSlider" .. "Text"):SetText(GUPPET_TEXT_OPTIONUI_MAIN_SCALE) ;
		getglobal("ScaleSlider" .. "Low"):SetText(GUPPET_TEXT_OPTIONUI_MAIN_MIN) ;
		getglobal("ScaleSlider" .. "High"):SetText(GUPPET_TEXT_OPTIONUI_MAIN_MAX) ;
		
		
		----------------------------------------------------------------------------
		GUPPET_INTERFACE.MainScherm.AutoCallCritterFrame = CreateFrame("FRAME", "AutoCallCritterFrame", GUPPET_INTERFACE.MainScherm , "GupPetFrameOptionFrame");
 		GUPPET_INTERFACE.MainScherm.AutoCallCritterFrame:SetWidth(190);
		GUPPET_INTERFACE.MainScherm.AutoCallCritterFrame:SetHeight(125);	
		GUPPET_INTERFACE.MainScherm.AutoCallCritterFrame:SetPoint("TOPRIGHT", -10 , -290);
		getglobal("AutoCallCritterFrame" .. "SubTitle"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_AUTOCALLCRITTER) ;	
		
		-------------------
		GUPPET_INTERFACE.MainScherm.AutoCallCritter = CreateFrame("CheckButton", "CheckButtonAutoCallCritter"  , GUPPET_INTERFACE.MainScherm.AutoCallCritterFrame, "OptionsSmallCheckButtonTemplate");
		GUPPET_INTERFACE.MainScherm.AutoCallCritter:SetPoint("TOPLEFT", 10, -10 );
		GUPPET_INTERFACE.MainScherm.AutoCallCritter:SetScript("OnClick", function (self, button, down)    GupPet_AutoCallCritterSetEnable( self:GetChecked() , GUPPET_OPTIONS.AutoCallCritterCityOnly )  end);
		GUPPET_INTERFACE.MainScherm.AutoCallCritter:SetChecked(  GUPPET_OPTIONS.AutoCallCritter ); 
		
		getglobal("CheckButtonAutoCallCritter" .. "Text"):SetText( GUPPET_TEXT_OPTIONUI_ENABLE  ) ;
		--
		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.MainScherm.AutoCallCritterCityOnly = CreateFrame("CheckButton", "CheckButtonAutoCallCritterCityOnly"  , GUPPET_INTERFACE.MainScherm.AutoCallCritterFrame, "GupPetOptionsCheckButtonTemplate");
		GUPPET_INTERFACE.MainScherm.AutoCallCritterCityOnly:SetPoint("TOPLEFT", 20, -32 );
		GUPPET_INTERFACE.MainScherm.AutoCallCritterCityOnly:SetScript("OnClick", function (self, button, down)    GupPet_AutoCallCritterSetEnable( true , self:GetChecked() )  end);
		GUPPET_INTERFACE.MainScherm.AutoCallCritterCityOnly:SetChecked(  GUPPET_OPTIONS.AutoCallCritterCityOnly ); 
			
		getglobal("CheckButtonAutoCallCritterCityOnly" .. "Title"):SetText( GUPPET_TEXT_OPTIONUI_AUTOCALLCRITTERCITYONLY  ) ;
		--
		----------------------------------------------------
		-- 		
		GUPPET_INTERFACE.MainScherm.DelaySlider = CreateFrame('Slider', "DelaySlider", GUPPET_INTERFACE.MainScherm.AutoCallCritterFrame , 'OptionsSliderTemplate');
		GUPPET_INTERFACE.MainScherm.DelaySlider:SetPoint('TOP', 0, -80);
		GUPPET_INTERFACE.MainScherm.DelaySlider:SetOrientation('HORIZONTAL');
		GUPPET_INTERFACE.MainScherm.DelaySlider:SetWidth(120) ;
		GUPPET_INTERFACE.MainScherm.DelaySlider:SetHeight(20);
		GUPPET_INTERFACE.MainScherm.DelaySlider:SetMinMaxValues(2 , 7 );
		GUPPET_INTERFACE.MainScherm.DelaySlider:SetValueStep(0.1) ;
		GUPPET_INTERFACE.MainScherm.DelaySlider:SetValue( GUPPET_OPTIONS.AutoCallCritterDelay );
		GUPPET_INTERFACE.MainScherm.DelaySlider:SetScript("OnValueChanged", function (self)   GUPPET_OPTIONS.AutoCallCritterDelay = self:GetValue() ;       end);

		getglobal("DelaySlider" .. "Text"):SetText(GUPPET_TEXT_OPTIONUI_MAIN_DELAY) ;
		getglobal("DelaySlider" .. "Low"):SetText(GUPPET_TEXT_OPTIONUI_MAIN_MIN) ;
		getglobal("DelaySlider" .. "High"):SetText(GUPPET_TEXT_OPTIONUI_MAIN_MAX) ;
		----------------------------------------------------------------------------
		
	end
	
-- ############################################# 
-- #############################################  GROUND MOUNTS
-- #############################################	
	
	if (GUPPET_INTERFACE.Init == 0 ) then
		
		GUPPET_INTERFACE.SubSchermGroundMounts = CreateFrame("FRAME", "SubSchermGroundMounts" , nil , "GupPetFrameOptionMain" );
		GUPPET_INTERFACE.SubSchermGroundMounts.name = GUPPET_TEXT_OPTIONUI_GROUNDMOUNTS ; 
		GUPPET_INTERFACE.SubSchermGroundMounts.parent = "Gup Pet"; 
				
		getglobal(GUPPET_INTERFACE.SubSchermGroundMounts:GetName() .. "Text"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_GROUNDMOUNTS) ;
		
		-------------------
		--
		GUPPET_INTERFACE.SubSchermGroundMounts.Creature = CreateFrame("FRAME", "CreatureModelFrameGround", GUPPET_INTERFACE.SubSchermGroundMounts , "GupPetFrameCreature"); 
		--
		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.SubSchermGroundMounts.Slow = {} ;
		GUPPET_INTERFACE.SubSchermGroundMounts.Fast = {} ;
		GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic = {} ;

		GUPPET_INTERFACE.SubSchermGroundMounts.Slow["Temp"] = 0 ;	
		GUPPET_INTERFACE.SubSchermGroundMounts.Fast["Temp"] = 0 ;	
		GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic["Temp"] = 0 ;	
		--
		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.SubSchermGroundMounts.Slow.ScrollFrame = CreateFrame("FRAME", "SlowGroundMount", GUPPET_INTERFACE.SubSchermGroundMounts , "GupPetFrameOptionMasterE");
 		GUPPET_INTERFACE.SubSchermGroundMounts.Slow.ScrollFrame:SetWidth(190);
		GUPPET_INTERFACE.SubSchermGroundMounts.Slow.ScrollFrame:SetHeight(205);	
		GUPPET_INTERFACE.SubSchermGroundMounts.Slow.ScrollFrame:SetPoint("TOPLEFT", 10 , -60);
			
		getglobal("SlowGroundMount" .. "SubTitle"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_GROUNDMOUNTSSLOW) ;	
		getglobal("SlowGroundMount" .. "Enable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "SlowGroundMount", 9999 , true , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;
		getglobal("SlowGroundMount" .. "Disable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "SlowGroundMount", 9999 , false , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;		

		getglobal("SlowGroundMount" .. "Container"):SetWidth(158);
		getglobal("SlowGroundMount" .. "Container"):SetHeight(195);
		getglobal("SlowGroundMount" .. "Container"):SetScrollChild( getglobal("SlowGroundMount" .. "Data") )
		--
		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic.ScrollFrame = CreateFrame("FRAME", "AquaticGroundMount", GUPPET_INTERFACE.SubSchermGroundMounts , "GupPetFrameOptionMasterE"); 
		GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic.ScrollFrame:SetWidth(190);
		GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic.ScrollFrame:SetHeight(115);	
		GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic.ScrollFrame:SetPoint("TOPLEFT", 10 , -300);
		
		getglobal("AquaticGroundMount" .. "SubTitle"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_GROUNDMOUNTSAQUATIC) ;	
		getglobal("AquaticGroundMount" .. "Enable" ):SetScript("OnClick", function () GupPetPanel_SetStatus( "AquaticMount", 9999 , true , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;
		getglobal("AquaticGroundMount" .. "Disable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "AquaticMount", 9999 , false , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;		
			
		getglobal("AquaticGroundMount" .. "Container"):SetWidth(158);
		getglobal("AquaticGroundMount" .. "Container"):SetHeight(105);
		getglobal("AquaticGroundMount" .. "Container"):SetScrollChild( getglobal("AquaticGroundMount" .. "Data") )	
		--	
		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.SubSchermGroundMounts.Fast.ScrollFrame = CreateFrame("FRAME", "FastGroundMount", GUPPET_INTERFACE.SubSchermGroundMounts , "GupPetFrameOptionMasterE"); 
		GUPPET_INTERFACE.SubSchermGroundMounts.Fast.ScrollFrame:SetWidth(190);
		GUPPET_INTERFACE.SubSchermGroundMounts.Fast.ScrollFrame:SetHeight(355);
		GUPPET_INTERFACE.SubSchermGroundMounts.Fast.ScrollFrame:SetPoint("TOPRIGHT", -10 , -60);
		
		getglobal("FastGroundMount" .. "SubTitle"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_GROUNDMOUNTSFAST) ;	
		getglobal("FastGroundMount" .. "Enable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastGroundMount", 9999 , true , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;
		getglobal("FastGroundMount" .. "Disable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastGroundMount", 9999 , false , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;		
		
		getglobal("FastGroundMount" .. "Container"):SetWidth(158);
		getglobal("FastGroundMount" .. "Container"):SetHeight(345);
		getglobal("FastGroundMount" .. "Container"):SetScrollChild( getglobal("FastGroundMount" .. "Data") )
		--
		----------------------------------------------------
	end
		
	t_i = 0 ;	
	
	for i = 1 , GUPPET_MOUNTS["SlowGroundMount"]["Total"] do

		if (GUPPET_INTERFACE.SubSchermGroundMounts.Slow.Temp < i ) then
			GUPPET_INTERFACE.SubSchermGroundMounts.Slow[ i ] = CreateFrame("CheckButton", "CheckButtonSlowGroundMount"..i  , getglobal("SlowGroundMount" .. "Data") , "GupPetOptionsCheckButtonTemplate");
			GUPPET_INTERFACE.SubSchermGroundMounts.Slow[ i ]:SetPoint("TOPLEFT", 0, 15 - (i*15));
			GUPPET_INTERFACE.SubSchermGroundMounts.Slow[ i ]:SetScript("OnClick", function (self, button, down)    GupPetPanel_SetStatus( "SlowGroundMount" , self:GetID() , self:GetChecked() , "Enabled" , "TotalEnabled" )  end);
			GUPPET_INTERFACE.SubSchermGroundMounts.Slow[ i ]:SetScript("OnEnter", function(self, button, down)	GUPPET_INTERFACE.SubSchermGroundMounts.Creature.Model:SetCreature( GUPPET_MOUNTS["SlowGroundMount"][ self:GetID() ]["CreatureID"]  )	GUPPET_INTERFACE.SubSchermGroundMounts.Creature:Show() end);
			GUPPET_INTERFACE.SubSchermGroundMounts.Slow[ i ]:SetScript("OnLeave", function() GUPPET_INTERFACE.SubSchermGroundMounts.Creature:Hide()	end);	
		end
			
		getglobal("CheckButtonSlowGroundMount"..i .. "Title"):SetText( GUPPET_MOUNTS["SlowGroundMount"][ i ]["Name"]  ) ;
		GUPPET_INTERFACE.SubSchermGroundMounts.Slow[ i ]:SetChecked(  GUPPET_MOUNTS["SlowGroundMount"][ i ]["Enabled"] ); 
		GUPPET_INTERFACE.SubSchermGroundMounts.Slow[ i ]:SetID(i);
		
		t_i = i ;
	end

	---------------------------------------------------
	GUPPET_INTERFACE.SubSchermGroundMounts.Slow.Temp =  t_i ;
	t_i = 0 ;	
	
	GupPetScrollFrame_Update( getglobal("SlowGroundMount" .. "Container") , GUPPET_INTERFACE.SubSchermGroundMounts.Slow.Temp ,13 ,15 , 180);	

	
	for i = 1 , GUPPET_MOUNTS["AquaticMount"]["Total"] do

		if (GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic.Temp < i ) then
			GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic[ i ] = CreateFrame("CheckButton", "CheckButtonAquaticGroundMount"..i  , getglobal("AquaticGroundMount" .. "Data") , "GupPetOptionsCheckButtonTemplate");
			GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic[ i ]:SetPoint("TOPLEFT", 0, 15 - (i*15));
			GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic[ i ]:SetScript("OnClick", function (self, button, down)    GupPetPanel_SetStatus( "AquaticMount" , self:GetID() , self:GetChecked() , "Enabled" , "TotalEnabled" )  end);
			GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic[ i ]:SetScript("OnEnter", function(self, button, down)	GUPPET_INTERFACE.SubSchermGroundMounts.Creature.Model:SetCreature( GUPPET_MOUNTS["AquaticMount"][ self:GetID() ]["CreatureID"]  )	GUPPET_INTERFACE.SubSchermGroundMounts.Creature:Show() end);
			GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic[ i ]:SetScript("OnLeave", function() GUPPET_INTERFACE.SubSchermGroundMounts.Creature:Hide()	end);	
		end
			
		getglobal("CheckButtonAquaticGroundMount"..i .. "Title"):SetText( GUPPET_MOUNTS["AquaticMount"][ i ]["Name"]  ) ;
		GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic[ i ]:SetChecked(  GUPPET_MOUNTS["AquaticMount"][ i ]["Enabled"] ); 
		GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic[ i ]:SetID(i);
		
		t_i = i ;
	end
	
	---------------------------------------------------
	GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic.Temp =  t_i ;
	t_i = 0 ;	
	
	GupPetScrollFrame_Update( getglobal("AquaticGroundMount" .. "Container") , GUPPET_INTERFACE.SubSchermGroundMounts.Aquatic.Temp ,7 ,15 , 180);	
 
	---------------------------------------------------
	
	for i = 1 , GUPPET_MOUNTS["FastGroundMount"]["Total"] do
		
		if (GUPPET_INTERFACE.SubSchermGroundMounts.Fast.Temp < i ) then
			GUPPET_INTERFACE.SubSchermGroundMounts.Fast[ i ] = CreateFrame("CheckButton", "CheckButtonFastGroundMount"..i   , getglobal("FastGroundMount" .. "Data"), "GupPetOptionsCheckButtonTemplate");
			GUPPET_INTERFACE.SubSchermGroundMounts.Fast[ i ]:SetPoint("TOPLEFT", 0, 15 - (i*15));
			GUPPET_INTERFACE.SubSchermGroundMounts.Fast[ i ]:SetScript("OnClick", function (self, button, down)    GupPetPanel_SetStatus( "FastGroundMount" , self:GetID() , self:GetChecked() , "Enabled" , "TotalEnabled" )  end);
			GUPPET_INTERFACE.SubSchermGroundMounts.Fast[ i ]:SetScript("OnEnter", function(self, button, down)	GUPPET_INTERFACE.SubSchermGroundMounts.Creature.Model:SetCreature( GUPPET_MOUNTS["FastGroundMount"][ self:GetID() ]["CreatureID"]  )	GUPPET_INTERFACE.SubSchermGroundMounts.Creature:Show() end);
			GUPPET_INTERFACE.SubSchermGroundMounts.Fast[ i ]:SetScript("OnLeave", function() GUPPET_INTERFACE.SubSchermGroundMounts.Creature:Hide()	end);	
		end
		
		getglobal("CheckButtonFastGroundMount"..i .. "Title"):SetText( GUPPET_MOUNTS["FastGroundMount"][ i ]["Name"]  ) ;
		GUPPET_INTERFACE.SubSchermGroundMounts.Fast[ i ]:SetChecked(  GUPPET_MOUNTS["FastGroundMount"][ i ]["Enabled"] ); 
		GUPPET_INTERFACE.SubSchermGroundMounts.Fast[ i ]:SetID(i);
			
		t_i = i ;
	end
	
	GUPPET_INTERFACE.SubSchermGroundMounts.Fast.Temp =  t_i ;

	GupPetScrollFrame_Update( getglobal("FastGroundMount" .. "Container") , GUPPET_INTERFACE.SubSchermGroundMounts.Fast.Temp ,23 ,15 , 180);
	
	GupPet_Debug( "GupPetOptionInterface Passed FastGround" );	
		
-- ############################################# 
-- #############################################  FLY MOUNTS
-- #############################################	
	if (GUPPET_INTERFACE.Init == 0 ) then

	GUPPET_INTERFACE.SubSchermFlyMounts = CreateFrame("ScrollFrame", "SubSchermFlyMounts", nil , "GupPetFrameOptionMain" );  
		GUPPET_INTERFACE.SubSchermFlyMounts.name = GUPPET_TEXT_OPTIONUI_FLYMOUNTS; 
		GUPPET_INTERFACE.SubSchermFlyMounts.parent = "Gup Pet"; 

		getglobal(GUPPET_INTERFACE.SubSchermFlyMounts:GetName() .. "Text"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_FLYMOUNTS) ;

		GUPPET_INTERFACE.SubSchermFlyMounts.Creature = CreateFrame("FRAME", "CreatureModelFrameFly", GUPPET_INTERFACE.SubSchermFlyMounts , "GupPetFrameCreature"); 


		GUPPET_INTERFACE.SubSchermFlyMounts.Slow = {} ;
		GUPPET_INTERFACE.SubSchermFlyMounts.Fast = {} ;
		GUPPET_INTERFACE.SubSchermFlyMounts.Slow["Temp"] = 0 ;	
		GUPPET_INTERFACE.SubSchermFlyMounts.Fast["Temp"] = 0 ;	

		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.SubSchermFlyMounts.Slow.ScrollFrame = CreateFrame("FRAME", "SlowFlyMount", GUPPET_INTERFACE.SubSchermFlyMounts , "GupPetFrameOptionMasterE"); 
		GUPPET_INTERFACE.SubSchermFlyMounts.Slow.ScrollFrame:SetWidth(190);
		GUPPET_INTERFACE.SubSchermFlyMounts.Slow.ScrollFrame:SetHeight(355);
		GUPPET_INTERFACE.SubSchermFlyMounts.Slow.ScrollFrame:SetPoint("TOPLEFT", 10 , -60);
		
		getglobal("SlowFlyMount" .. "SubTitle"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_FLYMOUNTSSLOW) ;	
		getglobal("SlowFlyMount" .. "Enable" ):SetScript("OnClick", function () GupPetPanel_SetStatus( "SlowFlyMount", 9999 , true , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;
		getglobal("SlowFlyMount" .. "Disable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "SlowFlyMount", 9999 , false , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;	
		
		getglobal("SlowFlyMount" .. "Container"):SetWidth(158);
		getglobal("SlowFlyMount" .. "Container"):SetHeight(345);
		getglobal("SlowFlyMount" .. "Container"):SetScrollChild( getglobal("SlowFlyMount" .. "Data") )
		--	
		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.SubSchermFlyMounts.Fast.ScrollFrame = CreateFrame("FRAME", "FastFlyMount", GUPPET_INTERFACE.SubSchermFlyMounts , "GupPetFrameOptionMasterE"); 
		GUPPET_INTERFACE.SubSchermFlyMounts.Fast.ScrollFrame:SetWidth(190);
		GUPPET_INTERFACE.SubSchermFlyMounts.Fast.ScrollFrame:SetHeight(355);
		GUPPET_INTERFACE.SubSchermFlyMounts.Fast.ScrollFrame:SetPoint("TOPRIGHT", -10 , -60);
			
		getglobal("FastFlyMount" .. "SubTitle"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_FLYMOUNTSFAST) ;	
		getglobal("FastFlyMount" .. "Enable" ):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastFlyMount", 9999 , true , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;
		getglobal("FastFlyMount" .. "Disable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastFlyMount", 9999 , false , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;	
			
		getglobal("FastFlyMount" .. "Container"):SetWidth(158);
		getglobal("FastFlyMount" .. "Container"):SetHeight(345);
		getglobal("FastFlyMount" .. "Container"):SetScrollChild( getglobal("FastFlyMount" .. "Data") )	
		--	
		---------------------------------------------------- 
	end
		
	t_i = 0 ;	
	
	for i = 1 , GUPPET_MOUNTS["SlowFlyMount"]["Total"] do
				
		if (GUPPET_INTERFACE.SubSchermFlyMounts.Slow.Temp < i ) then
			GUPPET_INTERFACE.SubSchermFlyMounts.Slow[ i ] = CreateFrame("CheckButton", "CheckButtonSlowFlyMount"..i  , getglobal("SlowFlyMount" .. "Data"), "GupPetOptionsCheckButtonTemplate");
			GUPPET_INTERFACE.SubSchermFlyMounts.Slow[ i ]:SetPoint("TOPLEFT", 0, 15 - (i*15));
			GUPPET_INTERFACE.SubSchermFlyMounts.Slow[ i ]:SetScript("OnClick", function (self, button, down)    GupPetPanel_SetStatus( "SlowFlyMount" , self:GetID() , self:GetChecked() , "Enabled" , "TotalEnabled" )  end);
			GUPPET_INTERFACE.SubSchermFlyMounts.Slow[ i ]:SetScript("OnEnter", function(self, button, down)	GUPPET_INTERFACE.SubSchermFlyMounts.Creature.Model:SetCreature( GUPPET_MOUNTS["SlowFlyMount"][ self:GetID() ]["CreatureID"]  )	GUPPET_INTERFACE.SubSchermFlyMounts.Creature:Show() end);
			GUPPET_INTERFACE.SubSchermFlyMounts.Slow[ i ]:SetScript("OnLeave", function() GUPPET_INTERFACE.SubSchermFlyMounts.Creature:Hide()	end);	
		end
	
		getglobal("CheckButtonSlowFlyMount"..i .. "Title"):SetText( GUPPET_MOUNTS["SlowFlyMount"][ i ]["Name"]  ) ;
		GUPPET_INTERFACE.SubSchermFlyMounts.Slow[ i ]:SetChecked(  GUPPET_MOUNTS["SlowFlyMount"][ i ]["Enabled"] ); 
		GUPPET_INTERFACE.SubSchermFlyMounts.Slow[ i ]:SetID(i);
				
		t_i = i ;
	end
	GupPet_Debug( "GupPetOptionInterface Passed SlowFly" );
	---------------------------------------------------
	GUPPET_INTERFACE.SubSchermFlyMounts.Slow.Temp =  t_i ;
	t_i = 0 ;	
	
	GupPetScrollFrame_Update( getglobal("SlowFlyMount" .. "Container") , GUPPET_INTERFACE.SubSchermFlyMounts.Slow.Temp ,23 ,15 , 180);
	
	
	---------------------------------------------------
	
	for i = 1 , GUPPET_MOUNTS["FastFlyMount"]["Total"] do
				
		if (GUPPET_INTERFACE.SubSchermFlyMounts.Fast.Temp < i ) then 
			GUPPET_INTERFACE.SubSchermFlyMounts.Fast[ i ] = CreateFrame("CheckButton", "CheckButtonFastFlyMount"..i  , getglobal("FastFlyMount" .. "Data"), "GupPetOptionsCheckButtonTemplate");
			GUPPET_INTERFACE.SubSchermFlyMounts.Fast[ i ]:SetPoint("TOPLEFT", 0, 15 - (i*15));
			GUPPET_INTERFACE.SubSchermFlyMounts.Fast[ i ]:SetScript("OnClick", function (self, button, down)    GupPetPanel_SetStatus( "FastFlyMount" , self:GetID() , self:GetChecked() , "Enabled" , "TotalEnabled" )  end);
			GUPPET_INTERFACE.SubSchermFlyMounts.Fast[ i ]:SetScript("OnEnter", function(self, button, down)	GUPPET_INTERFACE.SubSchermFlyMounts.Creature.Model:SetCreature( GUPPET_MOUNTS["FastFlyMount"][ self:GetID() ]["CreatureID"]  )	GUPPET_INTERFACE.SubSchermFlyMounts.Creature:Show() end);
			GUPPET_INTERFACE.SubSchermFlyMounts.Fast[ i ]:SetScript("OnLeave", function() GUPPET_INTERFACE.SubSchermFlyMounts.Creature:Hide()	end);	
		end
		
		getglobal("CheckButtonFastFlyMount"..i .. "Title"):SetText( GUPPET_MOUNTS["FastFlyMount"][ i ]["Name"]  ) ;
		GUPPET_INTERFACE.SubSchermFlyMounts.Fast[ i ]:SetID(i);
		GUPPET_INTERFACE.SubSchermFlyMounts.Fast[ i ]:SetChecked(  GUPPET_MOUNTS["FastFlyMount"][ i ]["Enabled"] ); 
		
		t_i = i ;
	end	
	GUPPET_INTERFACE.SubSchermFlyMounts.Fast.Temp =  t_i ;
		
	GupPetScrollFrame_Update(getglobal("FastFlyMount" .. "Container") , GUPPET_INTERFACE.SubSchermFlyMounts.Fast.Temp ,23 ,15 , 180);
		
	GupPet_Debug( "GupPetOptionInterface Passed FastFly" );
	
-- ############################################# 
-- #############################################  CRITTERS
-- #############################################	

	if (GUPPET_INTERFACE.Init == 0 ) then
		GUPPET_INTERFACE.SubSchermCritters = CreateFrame("ScrollFrame", "SubSchermCritters", nil , "GupPetFrameOptionMain" ); 
		GUPPET_INTERFACE.SubSchermCritters.name = GUPPET_TEXT_OPTIONUI_CRITTERS; 
		GUPPET_INTERFACE.SubSchermCritters.parent = "Gup Pet"; 

		getglobal(GUPPET_INTERFACE.SubSchermCritters:GetName() .. "Text"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_CRITTERS) ;
		
		-------------------
		GUPPET_INTERFACE.SubSchermCritters.Creature = CreateFrame("FRAME", "CreatureModelFrame", GUPPET_INTERFACE.SubSchermCritters , "GupPetFrameCreature");
		-------------------	
		
		GUPPET_INTERFACE.SubSchermCritters.Left = {} ;
		GUPPET_INTERFACE.SubSchermCritters.Right = {} ;
		GUPPET_INTERFACE.SubSchermCritters.Left["Temp"] = 0 ;	
		GUPPET_INTERFACE.SubSchermCritters.Right["Temp"] = 0 ;	
		--
		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.SubSchermCritters.ScrollFrame = CreateFrame("FRAME", "Critters", GUPPET_INTERFACE.SubSchermCritters , "GupPetFrameOptionMasterE"); 
		GUPPET_INTERFACE.SubSchermCritters.ScrollFrame:SetWidth(393);
		GUPPET_INTERFACE.SubSchermCritters.ScrollFrame:SetHeight(355);
		GUPPET_INTERFACE.SubSchermCritters.ScrollFrame:SetPoint("TOPLEFT", 10 , -60);
			
		getglobal("Critters" .. "SubTitle"):SetText("") ;	
		getglobal("Critters" .. "Enable" ):SetScript("OnClick", function () GupPetPanel_SetStatus( "GUPPET_CRITTERS", 9999 , true , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;
		getglobal("Critters" .. "Disable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "GUPPET_CRITTERS", 9999 , false , "Enabled" , "TotalEnabled" ); GupPetOptionInterface() ;  end) ;		
		
		getglobal("Critters" .. "Container"):SetWidth(383);
		getglobal("Critters" .. "Container"):SetHeight(345);
		getglobal("Critters" .. "Container"):SetScrollChild( getglobal("Critters" .. "Data") )			
		--
		----------------------------------------------------
		-- 

	end
	
	t_i = 0 ;
	

	for i = 1 , math.ceil(GUPPET_CRITTERS["Total"]/2)  do
				
		if (GUPPET_INTERFACE.SubSchermCritters.Left.Temp < i ) then 		
	
			GUPPET_INTERFACE.SubSchermCritters.Left[ i ] = CreateFrame("CheckButton", "CheckButtonCrittersLeft"..i   , getglobal("Critters" .. "Data"), "GupPetOptionsCheckButtonTemplate");
			GUPPET_INTERFACE.SubSchermCritters.Left[ i ]:SetPoint("TOPLEFT", 0, 15 - (i*15));
			GUPPET_INTERFACE.SubSchermCritters.Left[ i ]:SetScript("OnClick", function (self, button, down)    GupPetPanel_SetStatus( "GUPPET_CRITTERS" , self:GetID() , self:GetChecked() , "Enabled" , "TotalEnabled" )  end);
			GUPPET_INTERFACE.SubSchermCritters.Left[ i ]:SetScript("OnEnter", function(self, button, down)	GUPPET_INTERFACE.SubSchermCritters.Creature.Model:SetCreature( GUPPET_CRITTERS[ self:GetID() ]["CreatureID"]  )	GUPPET_INTERFACE.SubSchermCritters.Creature:Show() end);
			GUPPET_INTERFACE.SubSchermCritters.Left[ i ]:SetScript("OnLeave", function() GUPPET_INTERFACE.SubSchermCritters.Creature:Hide()	end);	
		end			
		
		getglobal("CheckButtonCrittersLeft"..i .. "Title"):SetText( GUPPET_CRITTERS[ i ]["Name"]  ) ;
		GUPPET_INTERFACE.SubSchermCritters.Left[ i ]:SetID(i);
		GUPPET_INTERFACE.SubSchermCritters.Left[ i ]:SetChecked(  GUPPET_CRITTERS[ i ]["Enabled"] ); 
		
		t_i = i ;
	end	
	GUPPET_INTERFACE.SubSchermCritters.Left.Temp =  t_i ;
	t_i = 0 ;
	
	
	for i = 1 , GUPPET_CRITTERS["Total"]- math.ceil(GUPPET_CRITTERS["Total"]/2)  do
				
		if (GUPPET_INTERFACE.SubSchermCritters.Right.Temp < i ) then 		
	
			GUPPET_INTERFACE.SubSchermCritters.Right[ i ] = CreateFrame("CheckButton", "CheckButtonCrittersRight"..i  , getglobal("Critters" .. "Data"), "GupPetOptionsCheckButtonTemplate");
			GUPPET_INTERFACE.SubSchermCritters.Right[ i ]:SetPoint("TOPLEFT", 202, 15 - ((i)*15));
			GUPPET_INTERFACE.SubSchermCritters.Right[ i ]:SetScript("OnClick", function (self, button, down)    GupPetPanel_SetStatus( "GUPPET_CRITTERS" , self:GetID() , self:GetChecked() , "Enabled" , "TotalEnabled" )  end);
			GUPPET_INTERFACE.SubSchermCritters.Right[ i ]:SetScript("OnEnter", function(self, button, down)	GUPPET_INTERFACE.SubSchermCritters.Creature.Model:SetCreature( GUPPET_CRITTERS[ self:GetID() ]["CreatureID"]  )	GUPPET_INTERFACE.SubSchermCritters.Creature:Show() end);
			GUPPET_INTERFACE.SubSchermCritters.Right[ i ]:SetScript("OnLeave", function() GUPPET_INTERFACE.SubSchermCritters.Creature:Hide()	end);	
		end			
		
		GUPPET_INTERFACE.SubSchermCritters.Right[ i ]:SetID(i+math.ceil(GUPPET_CRITTERS["Total"]/2));
		GUPPET_INTERFACE.SubSchermCritters.Right[ i ]:SetChecked(  GUPPET_CRITTERS[ i+math.ceil(GUPPET_CRITTERS["Total"]/2) ]["Enabled"] ); 
		getglobal("CheckButtonCrittersRight"..i .. "Title"):SetText( GUPPET_CRITTERS[ i+math.ceil(GUPPET_CRITTERS["Total"]/2) ]["Name"]  ) ;
	
		t_i = i ;
	end	
	GUPPET_INTERFACE.SubSchermCritters.Right.Temp =  t_i ;
	
	GupPetScrollFrame_Update( getglobal("Critters" .. "Container") , GUPPET_INTERFACE.SubSchermCritters.Left.Temp ,23 ,15 , 383);
		
	GupPet_Debug( "GupPetOptionInterface Passed Critter" );
	
-- ############################################# 
-- #############################################  LOCATION DEPENDED
-- #############################################	
	
	if (GUPPET_INTERFACE.Init == 0 ) then
		
		GUPPET_INTERFACE.SubSchermLocationDependent = CreateFrame("ScrollFrame", "SubSchermLocationDependent", nil , "GupPetFrameOptionMain" ); 
		GUPPET_INTERFACE.SubSchermLocationDependent.name = GUPPET_TEXT_OPTIONUI_LOCATIONDEPENDENT; 
		GUPPET_INTERFACE.SubSchermLocationDependent.parent = "Gup Pet"; 

		getglobal(GUPPET_INTERFACE.SubSchermLocationDependent:GetName() .. "Text"):SetText("|cFFFFDE00".. GUPPET_TEXT_OPTIONUI_LOCATIONDEPENDENT) ;
				
		-------------------
		GUPPET_INTERFACE.SubSchermLocationDependent.Creature = CreateFrame("FRAME", "CreatureModelFrame", GUPPET_INTERFACE.SubSchermLocationDependent , "GupPetFrameCreature");
		-------------------
		
		GUPPET_INTERFACE.SubSchermLocationDependent.City = {} ;
		GUPPET_INTERFACE.SubSchermLocationDependent.Instance = {} ;
		GUPPET_INTERFACE.SubSchermLocationDependent.Arena = {} ;
		GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround = {} ;
				
		GUPPET_INTERFACE.SubSchermLocationDependent.City.Temp = 0 ;
		GUPPET_INTERFACE.SubSchermLocationDependent.Instance.Temp = 0 ;
		GUPPET_INTERFACE.SubSchermLocationDependent.Arena.Temp = 0 ;
		GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround.Temp = 0 ;
		--
		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.SubSchermLocationDependent.City.ScrollFrame = CreateFrame("FRAME", "FastGroundMountCity", GUPPET_INTERFACE.SubSchermLocationDependent , "GupPetFrameOptionMasterE"); 
		GUPPET_INTERFACE.SubSchermLocationDependent.City.ScrollFrame:SetWidth(190);
		GUPPET_INTERFACE.SubSchermLocationDependent.City.ScrollFrame:SetHeight(147); --355			--355-60/2
		GUPPET_INTERFACE.SubSchermLocationDependent.City.ScrollFrame:SetPoint("TOPLEFT", 10 , -60);
		
		getglobal("FastGroundMountCity" .. "SubTitle"):SetText(GUPPET_TEXT_OPTIONUI_CITY) ;	
		getglobal("FastGroundMountCity" .. "Enable" ):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastGroundMount", 9999 , true , "EnabledCity" , "TotalEnabledCity" ); GupPetOptionInterface() ;  end) ;
		getglobal("FastGroundMountCity" .. "Disable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastGroundMount", 9999 , false , "EnabledCity" , "TotalEnabledCity" ); GupPetOptionInterface() ;  end) ;	
		
		getglobal("FastGroundMountCity" .. "Container"):SetWidth(158);
		getglobal("FastGroundMountCity" .. "Container"):SetHeight(137);
		getglobal("FastGroundMountCity" .. "Container"):SetScrollChild( getglobal("FastGroundMountCity" .. "Data") )		
		--
		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.SubSchermLocationDependent.Instance.ScrollFrame = CreateFrame("FRAME", "FastGroundMountInstance", GUPPET_INTERFACE.SubSchermLocationDependent , "GupPetFrameOptionMasterE"); 
		GUPPET_INTERFACE.SubSchermLocationDependent.Instance.ScrollFrame:SetWidth(190);
		GUPPET_INTERFACE.SubSchermLocationDependent.Instance.ScrollFrame:SetHeight(147);  
		GUPPET_INTERFACE.SubSchermLocationDependent.Instance.ScrollFrame:SetPoint("TOPRIGHT", -10 , -60);
			
		getglobal("FastGroundMountInstance" .. "SubTitle"):SetText(GUPPET_TEXT_OPTIONUI_INSTANCE) ;	
		getglobal("FastGroundMountInstance" .. "Enable" ):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastGroundMount", 9999 , true , "EnabledInstance" , "TotalEnabledInstance" ); GupPetOptionInterface() ;  end) ;
		getglobal("FastGroundMountInstance" .. "Disable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastGroundMount", 9999 , false , "EnabledInstance" , "TotalEnabledInstance" ); GupPetOptionInterface() ;  end) ;	

		getglobal("FastGroundMountInstance" .. "Container"):SetWidth(158);
		getglobal("FastGroundMountInstance" .. "Container"):SetHeight(137);
		getglobal("FastGroundMountInstance" .. "Container"):SetScrollChild( getglobal("FastGroundMountInstance" .. "Data") )	
		--
		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.SubSchermLocationDependent.Arena.ScrollFrame = CreateFrame("FRAME", "FastGroundMountArena", GUPPET_INTERFACE.SubSchermLocationDependent , "GupPetFrameOptionMasterE"); 
		GUPPET_INTERFACE.SubSchermLocationDependent.Arena.ScrollFrame:SetWidth(190);
		GUPPET_INTERFACE.SubSchermLocationDependent.Arena.ScrollFrame:SetHeight(147); --355			--355-60/2
		GUPPET_INTERFACE.SubSchermLocationDependent.Arena.ScrollFrame:SetPoint("TOPLEFT", 10 , -40-60-147);
		
		getglobal("FastGroundMountArena" .. "SubTitle"):SetText(GUPPET_TEXT_OPTIONUI_ARENA) ;	
		getglobal("FastGroundMountArena" .. "Enable" ):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastGroundMount", 9999 , true , "EnabledArena" , "TotalEnabledArena" ); GupPetOptionInterface() ;  end) ;
		getglobal("FastGroundMountArena" .. "Disable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastGroundMount", 9999 , false , "EnabledArena" , "TotalEnabledArena" ); GupPetOptionInterface() ;  end) ;	

		getglobal("FastGroundMountArena" .. "Container"):SetWidth(158);
		getglobal("FastGroundMountArena" .. "Container"):SetHeight(137);
		getglobal("FastGroundMountArena" .. "Container"):SetScrollChild( getglobal("FastGroundMountArena" .. "Data") )	
		--
		----------------------------------------------------
		-- 
		GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround.ScrollFrame = CreateFrame("FRAME", "FastGroundMountBattleGround", GUPPET_INTERFACE.SubSchermLocationDependent , "GupPetFrameOptionMasterE"); 
		GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround.ScrollFrame:SetWidth(190);
		GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround.ScrollFrame:SetHeight(147); --355			--355-60/2
		GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround.ScrollFrame:SetPoint("TOPRIGHT", -10 , -40-60-147);
			
		getglobal("FastGroundMountBattleGround" .. "SubTitle"):SetText(GUPPET_TEXT_OPTIONUI_BATTLEGROUND) ;	
		getglobal("FastGroundMountBattleGround" .. "Enable" ):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastGroundMount", 9999 , true , "EnabledBattleGround" , "TotalEnabledBattleGround" ); GupPetOptionInterface() ;  end) ;
		getglobal("FastGroundMountBattleGround" .. "Disable"):SetScript("OnClick", function () GupPetPanel_SetStatus( "FastGroundMount", 9999 , false , "EnabledBattleGround" , "TotalEnabledBattleGround" ); GupPetOptionInterface() ;  end) ;	
			
		getglobal("FastGroundMountBattleGround" .. "Container"):SetWidth(158);
		getglobal("FastGroundMountBattleGround" .. "Container"):SetHeight(137);
		getglobal("FastGroundMountBattleGround" .. "Container"):SetScrollChild( getglobal("FastGroundMountBattleGround" .. "Data") )	
		--
		----------------------------------------------------
		
	end
	
	for i = 1 , GUPPET_MOUNTS["FastGroundMount"]["Total"] do
				
		if (GUPPET_INTERFACE.SubSchermLocationDependent.City.Temp < i ) then 
			GUPPET_INTERFACE.SubSchermLocationDependent.City[ i ] = CreateFrame("CheckButton", "CheckButtonCity"..i  , getglobal("FastGroundMountCity" .. "Data"), "GupPetOptionsCheckButtonTemplate");
			GUPPET_INTERFACE.SubSchermLocationDependent.City[ i ]:SetPoint("TOPLEFT", 0, 15 - (i*15));
			GUPPET_INTERFACE.SubSchermLocationDependent.City[ i ]:SetScript("OnClick", function (self, button, down)    GupPetPanel_SetStatus( "FastGroundMount" , self:GetID() , self:GetChecked() , "EnabledCity" , "TotalEnabledCity" )  end);
			GUPPET_INTERFACE.SubSchermLocationDependent.City[ i ]:SetScript("OnEnter", function(self, button, down)	GUPPET_INTERFACE.SubSchermLocationDependent.Creature.Model:SetCreature( GUPPET_MOUNTS["FastGroundMount"][ self:GetID() ]["CreatureID"]  )	GUPPET_INTERFACE.SubSchermLocationDependent.Creature:Show() end);
			GUPPET_INTERFACE.SubSchermLocationDependent.City[ i ]:SetScript("OnLeave", function() GUPPET_INTERFACE.SubSchermLocationDependent.Creature:Hide()	end);	
		end
		
		GUPPET_INTERFACE.SubSchermLocationDependent.City[ i ]:SetID(i);
		GUPPET_INTERFACE.SubSchermLocationDependent.City[ i ]:SetChecked(  GUPPET_MOUNTS["FastGroundMount"][ i ]["EnabledCity"] ); 
		getglobal("CheckButtonCity"..i .. "Title"):SetText( GUPPET_MOUNTS["FastGroundMount"][ i ]["Name"]  ) ;

		t_i = i ;
	end	
	GUPPET_INTERFACE.SubSchermLocationDependent.City.Temp =  t_i ;
	
	GupPetScrollFrame_Update( getglobal("FastGroundMountCity" .. "Container") , GUPPET_INTERFACE.SubSchermLocationDependent.City.Temp ,9,15 , 180);

	for i = 1 , GUPPET_MOUNTS["FastGroundMount"]["Total"] do
				
		if (GUPPET_INTERFACE.SubSchermLocationDependent.Instance.Temp < i ) then 
			GUPPET_INTERFACE.SubSchermLocationDependent.Instance[ i ] = CreateFrame("CheckButton", "CheckButtonInstance"..i   , getglobal("FastGroundMountInstance" .. "Data"), "GupPetOptionsCheckButtonTemplate");
			GUPPET_INTERFACE.SubSchermLocationDependent.Instance[ i ]:SetPoint("TOPLEFT", 0, 15 - (i*15));
			GUPPET_INTERFACE.SubSchermLocationDependent.Instance[ i ]:SetScript("OnClick", function (self, button, down)    GupPetPanel_SetStatus( "FastGroundMount" , self:GetID() , self:GetChecked() , "EnabledInstance" , "TotalEnabledInstance" )  end);
			GUPPET_INTERFACE.SubSchermLocationDependent.Instance[ i ]:SetScript("OnEnter", function(self, button, down)	GUPPET_INTERFACE.SubSchermLocationDependent.Creature.Model:SetCreature( GUPPET_MOUNTS["FastGroundMount"][ self:GetID() ]["CreatureID"]  )	GUPPET_INTERFACE.SubSchermLocationDependent.Creature:Show() end);
			GUPPET_INTERFACE.SubSchermLocationDependent.Instance[ i ]:SetScript("OnLeave", function() GUPPET_INTERFACE.SubSchermLocationDependent.Creature:Hide()	end);	
		end
		
		GUPPET_INTERFACE.SubSchermLocationDependent.Instance[ i ]:SetID(i);
		GUPPET_INTERFACE.SubSchermLocationDependent.Instance[ i ]:SetChecked(  GUPPET_MOUNTS["FastGroundMount"][ i ]["EnabledInstance"] ); 
		getglobal("CheckButtonInstance"..i .. "Title"):SetText( GUPPET_MOUNTS["FastGroundMount"][ i ]["Name"]  ) ;
			
		t_i = i ;
	end	
	GUPPET_INTERFACE.SubSchermLocationDependent.Instance.Temp =  t_i ;
		
	GupPetScrollFrame_Update(getglobal("FastGroundMountInstance" .. "Container") , GUPPET_INTERFACE.SubSchermLocationDependent.Instance.Temp ,9,15 , 180);
		
	---------------------------------------------------
	for i = 1 , GUPPET_MOUNTS["FastGroundMount"]["Total"] do
				
		if (GUPPET_INTERFACE.SubSchermLocationDependent.Arena.Temp < i ) then 
			GUPPET_INTERFACE.SubSchermLocationDependent.Arena[ i ] = CreateFrame("CheckButton", "CheckButtonArena"..i   , getglobal("FastGroundMountArena" .. "Data"), "GupPetOptionsCheckButtonTemplate");
			GUPPET_INTERFACE.SubSchermLocationDependent.Arena[ i ]:SetPoint("TOPLEFT", 0, 15 - (i*15));
			GUPPET_INTERFACE.SubSchermLocationDependent.Arena[ i ]:SetScript("OnClick", function (self, button, down)    GupPetPanel_SetStatus( "FastGroundMount" , self:GetID() , self:GetChecked() , "EnabledArena" , "TotalEnabledArena" )  end);
			GUPPET_INTERFACE.SubSchermLocationDependent.Arena[ i ]:SetScript("OnEnter", function(self, button, down)	GUPPET_INTERFACE.SubSchermLocationDependent.Creature.Model:SetCreature( GUPPET_MOUNTS["FastGroundMount"][ self:GetID() ]["CreatureID"]  )	GUPPET_INTERFACE.SubSchermLocationDependent.Creature:Show() end);
			GUPPET_INTERFACE.SubSchermLocationDependent.Arena[ i ]:SetScript("OnLeave", function() GUPPET_INTERFACE.SubSchermLocationDependent.Creature:Hide()	end);	
		end
		
		GUPPET_INTERFACE.SubSchermLocationDependent.Arena[ i ]:SetID(i);
		GUPPET_INTERFACE.SubSchermLocationDependent.Arena[ i ]:SetChecked(  GUPPET_MOUNTS["FastGroundMount"][ i ]["EnabledArena"] ); 
		getglobal("CheckButtonArena"..i .. "Title"):SetText( GUPPET_MOUNTS["FastGroundMount"][ i ]["Name"]  ) ;
			
		t_i = i ;
	end	
	GUPPET_INTERFACE.SubSchermLocationDependent.Arena.Temp =  t_i ;
		
	GupPetScrollFrame_Update(getglobal("FastGroundMountArena" .. "Container") , GUPPET_INTERFACE.SubSchermLocationDependent.Arena.Temp ,9,15 , 180);
		
	for i = 1 , GUPPET_MOUNTS["FastGroundMount"]["Total"] do
				
		if (GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround.Temp < i ) then 
			GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround[ i ] = CreateFrame("CheckButton", "CheckButtonBattleGround"..i   , getglobal("FastGroundMountBattleGround" .. "Data"), "GupPetOptionsCheckButtonTemplate");
			GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround[ i ]:SetPoint("TOPLEFT", 0, 15 - (i*15));
			GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround[ i ]:SetScript("OnClick", function (self, button, down)    GupPetPanel_SetStatus( "FastGroundMount" , self:GetID() , self:GetChecked() , "EnabledBattleGround" , "TotalEnabledBattleGround" )  end);
			GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround[ i ]:SetScript("OnEnter", function(self, button, down)	GUPPET_INTERFACE.SubSchermLocationDependent.Creature.Model:SetCreature( GUPPET_MOUNTS["FastGroundMount"][ self:GetID() ]["CreatureID"]  )	GUPPET_INTERFACE.SubSchermLocationDependent.Creature:Show() end);
			GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround[ i ]:SetScript("OnLeave", function() GUPPET_INTERFACE.SubSchermLocationDependent.Creature:Hide()	end);	
		end
		
		GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround[ i ]:SetID(i);
		GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround[ i ]:SetChecked(  GUPPET_MOUNTS["FastGroundMount"][ i ]["EnabledBattleGround"] ); 
		getglobal("CheckButtonBattleGround"..i .. "Title"):SetText( GUPPET_MOUNTS["FastGroundMount"][ i ]["Name"]  ) ;
			
		t_i = i ;
	end	
	GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround.Temp =  t_i ;
		
	GupPetScrollFrame_Update(getglobal("FastGroundMountBattleGround" .. "Container") , GUPPET_INTERFACE.SubSchermLocationDependent.BattleGround.Temp ,9,15 , 180);
	
			
	---		---		---		---
	if (GUPPET_INTERFACE.Init == 0 ) then
	
		InterfaceOptions_AddCategory(GUPPET_INTERFACE.MainScherm);
				
		InterfaceOptions_AddCategory(GUPPET_INTERFACE.SubSchermGroundMounts);
		InterfaceOptions_AddCategory(GUPPET_INTERFACE.SubSchermFlyMounts);
		InterfaceOptions_AddCategory(GUPPET_INTERFACE.SubSchermLocationDependent);
		
		InterfaceOptions_AddCategory(GUPPET_INTERFACE.SubSchermCritters); 	
			
	end
end
	
	
function GupPetUIInterface()	

	GupPet_Debug( "GupPetOptionInterface Start IngameInterface" );
	if (GUPPET_INTERFACE.Init == 0 ) then
		GUPPET_INTERFACE.MainUI = {} ;
		
		--Frame Voor te slepen
		GUPPET_INTERFACE.MainUI.Frame = CreateFrame("FRAME", "hdsgfsdf", UIParent);   
				
		GUPPET_INTERFACE.MainUI.Frame:SetWidth((64+3));
		GUPPET_INTERFACE.MainUI.Frame:SetHeight(32);
		GUPPET_INTERFACE.MainUI.Frame:SetClampedToScreen( true ) ; 
		GUPPET_INTERFACE.MainUI.Frame:SetPoint( GUPPET_INTERFACEOPTIONS.MainUIFrameRelativePoint , GUPPET_INTERFACEOPTIONS.MainUIFramexOfs , GUPPET_INTERFACEOPTIONS.MainUIFrameyOfs);
			
		if GUPPET_INTERFACEOPTIONS.MainUIFrameShow == false then
			GUPPET_INTERFACE.MainUI.Frame:Hide() ;
		end
			
		GUPPET_INTERFACE.MainUI.buttonMount = CreateFrame("Button", "buttonMount", GUPPET_INTERFACE.MainUI.Frame , "GupPetActionTemplate");
		GUPPET_INTERFACE.MainUI.buttonMount:SetText("Mount");
		GUPPET_INTERFACE.MainUI.buttonMount:SetScript("OnClick", function (self, button, down) GupPet_AutoMount(); end) ;
		GUPPET_INTERFACE.MainUI.buttonMount:SetPoint("CENTER",-17.5,0);
		GUPPET_INTERFACE.MainUI.buttonMount.tooltipText = GUPPET_TEXT_UI_MOUNTGAMETOOLTIP ; 
		GUPPET_INTERFACE.MainUI.buttonMount.tooltipRequirement = GUPPET_TEXT_UI_MOUNTGAMETOOLTIPREQUIREMENT ; 
		
		getglobal("buttonMount" .. "Icon"):SetTexture("Interface\\Icons\\Ability_Mount_Drake_Azure.blp") ;
	
		GUPPET_INTERFACE.MainUI.buttonCritter = CreateFrame("Button", "buttonCritter", GUPPET_INTERFACE.MainUI.Frame , "GupPetActionTemplate"); 
		GUPPET_INTERFACE.MainUI.buttonCritter:SetText("Critter");
		GUPPET_INTERFACE.MainUI.buttonCritter:SetScript("OnClick", function (self, button, down) GupPet_CallCritter(); end) ;
		GUPPET_INTERFACE.MainUI.buttonCritter:SetPoint("CENTER",17.5,0);
		GUPPET_INTERFACE.MainUI.buttonCritter.tooltipText = GUPPET_TEXT_UI_CRITTERGAMETOOLTIP ; 
				
		getglobal("buttonCritter" .. "Icon"):SetTexture("Interface\\Icons\\INV_Box_PetCarrier_01.blp") ;
		
		-- Move Button Left
		GUPPET_INTERFACE.MainUI.buttonMoveL = CreateFrame("Button", "buttonMoveL", GUPPET_INTERFACE.MainUI.Frame , "UIPanelButtonTemplate"); 
		GUPPET_INTERFACE.MainUI.buttonMoveL:SetText("");
		GUPPET_INTERFACE.MainUI.buttonMoveL:SetWidth(10); 
		GUPPET_INTERFACE.MainUI.buttonMoveL:SetHeight(10); 
		GUPPET_INTERFACE.MainUI.buttonMoveL:SetPoint("TOPLEFT",-10 ,10 );
		GUPPET_INTERFACE.MainUI.buttonMoveL:Hide();
		GUPPET_INTERFACE.MainUI.buttonMoveL:SetScript("OnMouseDown", function(self, button, down)
	   
			GupPet_Debug( "GupPetOptionInterfaceDrag OnMouseDown" );
			GUPPET_INTERFACE.MainUI.Frame:StartMoving();
		
		end);

		GUPPET_INTERFACE.MainUI.buttonMoveL:SetScript("OnMouseUp", function(self, button, down)
	   			
			GUPPET_INTERFACE.MainUI.Frame:StopMovingOrSizing() ;
		
			_, _, GUPPET_INTERFACEOPTIONS.MainUIFrameRelativePoint, GUPPET_INTERFACEOPTIONS.MainUIFramexOfs, GUPPET_INTERFACEOPTIONS.MainUIFrameyOfs = GUPPET_INTERFACE.MainUI.Frame:GetPoint()
			
			GupPet_Debug( "relativePoint: ".. GUPPET_INTERFACEOPTIONS.MainUIFrameRelativePoint );
			GupPet_Debug( "GupPetOptionInterfaceDrag X: ".. GUPPET_INTERFACEOPTIONS.MainUIFramexOfs );
			GupPet_Debug( "GupPetOptionInterfaceDrag Y: ".. GUPPET_INTERFACEOPTIONS.MainUIFrameyOfs );
		end);
		
		
		-- Move Button Right
		GUPPET_INTERFACE.MainUI.buttonMoveR = CreateFrame("Button", "buttonMoveR", GUPPET_INTERFACE.MainUI.Frame , "UIPanelButtonTemplate"); 
		GUPPET_INTERFACE.MainUI.buttonMoveR:SetText("");
		GUPPET_INTERFACE.MainUI.buttonMoveR:SetWidth(10); 
		GUPPET_INTERFACE.MainUI.buttonMoveR:SetHeight(10); 
		GUPPET_INTERFACE.MainUI.buttonMoveR:SetPoint("TOPRIGHT",10 ,10 );
		GUPPET_INTERFACE.MainUI.buttonMoveR:Hide();
		GUPPET_INTERFACE.MainUI.buttonMoveR:SetScript("OnMouseDown", function(self, button, down)
	   
			GupPet_Debug( "GupPetOptionInterfaceDrag OnMouseDown" );
			GUPPET_INTERFACE.MainUI.Frame:StartMoving();
		
		end);

		GUPPET_INTERFACE.MainUI.buttonMoveR:SetScript("OnMouseUp", function(self, button, down)
	   			
			GUPPET_INTERFACE.MainUI.Frame:StopMovingOrSizing() ;
		
			_, _, GUPPET_INTERFACEOPTIONS.MainUIFrameRelativePoint, GUPPET_INTERFACEOPTIONS.MainUIFramexOfs, GUPPET_INTERFACEOPTIONS.MainUIFrameyOfs = GUPPET_INTERFACE.MainUI.Frame:GetPoint()
			
			GupPet_Debug( "relativePoint: ".. GUPPET_INTERFACEOPTIONS.MainUIFrameRelativePoint );
			GupPet_Debug( "GupPetOptionInterfaceDrag X: ".. GUPPET_INTERFACEOPTIONS.MainUIFramexOfs );
			GupPet_Debug( "GupPetOptionInterfaceDrag Y: ".. GUPPET_INTERFACEOPTIONS.MainUIFrameyOfs );
		end);
		
		
		
		GupPetOptionInterfaceDrag( GUPPET_INTERFACEOPTIONS.MainUIFrameDrag ) ;
	end
		GUPPET_INTERFACE.MainUI.Frame:SetScale( GUPPET_INTERFACEOPTIONS.MainUIFrameScale );
		
		GUPPET_INTERFACE.MainUI.Frame:SetPoint( GUPPET_INTERFACEOPTIONS.MainUIFrameRelativePoint , GUPPET_INTERFACEOPTIONS.MainUIFramexOfs , GUPPET_INTERFACEOPTIONS.MainUIFrameyOfs);
	
	GupPet_Debug( "GupPetOptionInterface Passed IngameInterface" );
	
	GUPPET_INTERFACE.Init = 1 ;	
	GupPet_Debug( "GupPetOptionInterface End" );
end


function GupPetInterface_ButtonCritterShow( show )

	if show then
	
		GUPPET_INTERFACE.MainUI.buttonCritter:Show() ;
		GUPPET_INTERFACE.MainUI.buttonMount:SetPoint("CENTER",-17.5,0);
		GUPPET_INTERFACE.MainUI.Frame:SetWidth(67); -- 32*2 +3
	
	else
		GUPPET_INTERFACE.MainUI.buttonCritter:Hide() ;
		GUPPET_INTERFACE.MainUI.buttonMount:SetPoint("CENTER",0,0);
		GUPPET_INTERFACE.MainUI.Frame:SetWidth(32);
	end
end




function GupPetOptionToggleMainUIFrameShow()

	if GUPPET_INTERFACEOPTIONS.MainUIFrameShow == true then
	
		GUPPET_INTERFACE.MainUI.Frame:Hide(); 
		GUPPET_INTERFACEOPTIONS.MainUIFrameShow=false ;
		GUPPET_INTERFACE.MainScherm.ToggleShow:SetText( GUPPET_TEXT_OPTIONUI_MAIN_SETSHOW );
	
	else
		GUPPET_INTERFACE.MainUI.Frame:Show(); 
		GUPPET_INTERFACEOPTIONS.MainUIFrameShow=true ;
		GUPPET_INTERFACE.MainScherm.ToggleShow:SetText( GUPPET_TEXT_OPTIONUI_MAIN_SETHIDE );
	end	
	
end

function GupPetOptionToggleMainUIFrameDrag()

		if GUPPET_INTERFACEOPTIONS.MainUIFrameDrag then
					
			GUPPET_INTERFACE.MainScherm.ToggleDrag:SetText( GUPPET_TEXT_OPTIONUI_MAIN_SETMOVABLE );
			GUPPET_INTERFACEOPTIONS.MainUIFrameDrag = false ;
			GupPetOptionInterfaceDrag(false);

		else
			GUPPET_INTERFACE.MainScherm.ToggleDrag:SetText( GUPPET_TEXT_OPTIONUI_MAIN_SETLOCK );
			
			GUPPET_INTERFACEOPTIONS.MainUIFrameDrag = true ;
			
			GupPetOptionInterfaceDrag(true);
		
		end		
end



function GupPetOptionInterfaceDrag( enable )

	GupPet_Debug( "GupPetOptionInterfaceDrag Start" );

	GUPPET_INTERFACE.MainUI.Frame:SetMovable( enable ) ;
	
	if enable then
	
		GUPPET_INTERFACE.MainUI.buttonMoveL:Show();
		GUPPET_INTERFACE.MainUI.buttonMoveR:Show();
	else 
		GUPPET_INTERFACE.MainUI.buttonMoveL:Hide();
		GUPPET_INTERFACE.MainUI.buttonMoveR:Hide();
	end

	GupPet_Debug( "GupPetOptionInterfaceDrag End" );
end



function GupPetScrollFrame_Update(frame, numItems, numToDisplay, valueStep , FrameWidth  )

	local frameName = frame:GetName();
	local scrollBar = getglobal( frameName.."ScrollBar" );
	local scrollChildFrame = getglobal( frameName.."ScrollChildFrame" );
	local scrollUpButton = getglobal( frameName.."ScrollBarScrollUpButton" );
	local scrollDownButton = getglobal( frameName.."ScrollBarScrollDownButton" );
	local scrollFrameHeight = 0;
	local scrollChildHeight = 0;

	if ( numItems > 0 ) then
		scrollFrameHeight = (numItems - numToDisplay) * valueStep;
		scrollChildHeight = numItems * valueStep;
		if ( scrollFrameHeight < 0 ) then
			scrollFrameHeight = 0;
		end
		scrollChildFrame:Show();
	else
		scrollChildFrame:Hide();
	end

	scrollBar:SetMinMaxValues(0, scrollFrameHeight); 
	scrollBar:SetValueStep(valueStep);
	scrollChildFrame:SetHeight(scrollChildHeight);
	
	if ( numItems > numToDisplay ) then
		scrollBar:Show();
		frame:SetWidth(FrameWidth-22) ;
	else
		frame:SetWidth(FrameWidth);
		scrollBar:Hide();
	end

	-- Arrow button handling
	if ( scrollBar:GetValue() == 0 ) then
		scrollUpButton:Disable();
	else
		scrollUpButton:Enable();
	end
		
	if ((scrollBar:GetValue() - scrollFrameHeight) == 0) then
		scrollDownButton:Disable();
	else
		scrollDownButton:Enable();
	end

end
